gcc_itsx.h File Reference
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | __TBB_OP_XACQUIRE 0xF2
#define | __TBB_OP_XRELEASE 0xF3
#define | __TBB_OP_LOCK 0xF0
#define | __TBB_STRINGIZE_INTERNAL(arg) #arg
#define | __TBB_STRINGIZE(arg) __TBB_STRINGIZE_INTERNAL(arg)
#define | __TBB_r_out "=q"

## Functions

static uint8_t | __TBB_machine_try_lock_elided (volatile uint8_t *lk)
static void | __TBB_machine_try_lock_elided_cancel ()
static void | __TBB_machine_unlock_elided (volatile uint8_t *lk)
static bool | __TBB_machine_is_in_transaction ()
static uint32_t | __TBB_machine_begin_transaction ()
static void | __TBB_machine_end_transaction ()
static void | __TBB_machine_transaction_conflict_abort ()

## Macro Definition Documentation

## __TBB_OP_LOCK

#define __TBB_OP_LOCK 0xF0

Definition at line 25 of file gcc_itsx.h.

## __TBB_OP_XACQUIRE

#define __TBB_OP_XACQUIRE 0xF2

Definition at line 23 of file gcc_itsx.h.

## __TBB_OP_XRELEASE

#define __TBB_OP_XRELEASE 0xF3

Definition at line 24 of file gcc_itsx.h.

## __TBB_r_out

#define __TBB_r_out "=q"

Definition at line 33 of file gcc_itsx.h.

## __TBB_STRINGIZE

#define __TBB_STRINGIZE | ( |  | arg | ) | __TBB_STRINGIZE_INTERNAL(arg)

Definition at line 28 of file gcc_itsx.h.

## __TBB_STRINGIZE_INTERNAL

#define __TBB_STRINGIZE_INTERNAL | ( |  | arg | ) | #arg

Definition at line 27 of file gcc_itsx.h.

## Function Documentation

## __TBB_machine_begin_transaction()

static uint32_t __TBB_machine_begin_transaction | ( |  | ) |

inline static

Enter speculative execution mode.

Returns
  -1 on success abort cause ( or 0 ) on abort

Definition at line 87 of file gcc_itsx.h.

{
uint32_t res = ~uint32_t(0); // success value
__asm__ volatile ("1: .byte 0xC7; .byte 0xF8;\n" // XBEGIN <abort-offset>
" .long 2f-1b-6\n" // 2f-1b == difference in addresses of start
// of XBEGIN and the MOVL
// 2f - 1b - 6 == that difference minus the size of the
// XBEGIN instruction. This is the abort offset to
// 2: below.
" jmp 3f\n" // success (leave -1 in res)
"2: movl %%eax,%0\n" // store failure code in res
"3:"
:"=r"(res):"0"(res):"memory","%eax");
return res;
}

## __TBB_machine_end_transaction()

static void __TBB_machine_end_transaction | ( |  | ) |

inline static

Attempt to commit/end transaction

Definition at line 106 of file gcc_itsx.h.

{
__asm__ volatile (".byte 0x0F; .byte 0x01; .byte 0xD5" :::"memory"); // XEND
}

## __TBB_machine_is_in_transaction()

static bool __TBB_machine_is_in_transaction | ( |  | ) |

inline static

Check if the instruction is executed in a transaction or not

Definition at line 69 of file gcc_itsx.h.

{
int8_t res = 0;
#if __TBB_x86_32
__asm__ volatile (".byte 0x0F; .byte 0x01; .byte 0xD6;\n"
"setz %0" : "=q"(res) : : "memory" );
#else
__asm__ volatile (".byte 0x0F; .byte 0x01; .byte 0xD6;\n"
"setz %0" : "=r"(res) : : "memory" );
#endif
return res==0;
}

## __TBB_machine_transaction_conflict_abort()

static void __TBB_machine_transaction_conflict_abort | ( |  | ) |

inline static

Definition at line 114 of file gcc_itsx.h.

{
__asm__ volatile (".byte 0xC6; .byte 0xF8; .byte 0xFF" :::"memory");
}

## __TBB_machine_try_lock_elided()

static uint8_t __TBB_machine_try_lock_elided | ( | volatile uint8_t * | lk | ) |

inline static

Definition at line 36 of file gcc_itsx.h.

{
uint8_t value = 1;
__asm__ volatile (".byte " __TBB_STRINGIZE(__TBB_OP_XACQUIRE)"; lock; xchgb %0, %1;"
: __TBB_r_out(value), "=m"(*lk) : "0"(value), "m"(*lk) : "memory" );
return uint8_t(value^1);
}

References __TBB_OP_XACQUIRE, __TBB_r_out, __TBB_STRINGIZE, and value.

## __TBB_machine_try_lock_elided_cancel()

static void __TBB_machine_try_lock_elided_cancel | ( |  | ) |

inline static

Definition at line 44 of file gcc_itsx.h.

{
// 'pause' instruction aborts HLE/RTM transactions
__asm__ volatile ("pause\n" : : : "memory" );
}

## __TBB_machine_unlock_elided()

static void __TBB_machine_unlock_elided | ( | volatile uint8_t * | lk | ) |

inline static

Definition at line 50 of file gcc_itsx.h.

{
__asm__ volatile (".byte " __TBB_STRINGIZE(__TBB_OP_XRELEASE)"; movb $0, %0"
: "=m"(*lk) : "m"(*lk) : "memory" );
}

References __TBB_OP_XRELEASE, and __TBB_STRINGIZE.

__TBB_STRINGIZE
#define __TBB_STRINGIZE(arg)
Definition: gcc_itsx.h:28
__TBB_OP_XACQUIRE
#define __TBB_OP_XACQUIRE
Definition: gcc_itsx.h:23
__TBB_OP_XRELEASE
#define __TBB_OP_XRELEASE
Definition: gcc_itsx.h:24
value
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain __itt_id ITT_FORMAT p const __itt_domain __itt_id __itt_timestamp __itt_timestamp ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain ITT_FORMAT p const __itt_domain __itt_string_handle unsigned long long value
Definition: ittnotify_static.h:192
__TBB_r_out
#define __TBB_r_out
Definition: gcc_itsx.h:33

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.